#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
# -----------------------------------------------------------------------------------------------
# THIS PLUGIN WAS DEVELOPED AND TESTED UNDER WINDOWS VISTA ONLY AND MAY OR MAY NOT WORK ON A MAC. 
# -----------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
# -----------------------------------------------------------------------------------------------
#    Name:	Joining The Dots
#      By:	sdmitch
#   Usage:	
#		 Note:	This is a special case plugin and is not applicable to any other situation
#						
#    Date:	May 2012
#------------------------------------------------------------------------------------------------
#
require 'Sketchup'
#
if not file_loaded?(File.basename(__FILE__))
    UI.menu('Plugins').add_item('Joining The Dots') { Joining_The_Dots.main }
		file_loaded(File.basename(__FILE__))
end
#
module Joining_The_Dots
	def self.main
		mod = Sketchup.active_model
		ent = mod.entities
		sel = mod.selection
		# collect the construction point locations in groups of 360
		pts=[];ring=[]
		ent.each{|e|
			if e.class==Sketchup::ConstructionPoint
				ring<<e.position
				if ring.length>=360
					pts<<ring;
					ring=[]
				end
			end
		}
# triangulate the rings
		for i in 0...360

			ent.add_face(pts[0][i],pts[2][i-1],pts[2][i])
			ent.add_face(pts[0][i],pts[0][i-1],pts[2][i-1])
			ent.add_face(pts[0][i],pts[4][i-1],pts[4][i])
			ent.add_face(pts[0][i],pts[0][i-1],pts[4][i-1])

			ent.add_face(pts[1][i],pts[3][i-1],pts[3][i])
			ent.add_face(pts[1][i],pts[1][i-1],pts[3][i-1])
			ent.add_face(pts[1][i],pts[5][i-1],pts[5][i])
			ent.add_face(pts[1][i],pts[1][i-1],pts[5][i-1])

		end
	end
end
